const Auth = require("../models/auth");
const TableTypes = require("../models/tabletypes");

const tableTypesModel = new TableTypes();


const showIndex = async(req, res, next) => {
    const authResult = await Auth.getSessionData(req.session.token); 
    const tableTypesResult = await tableTypesModel.findAll() || [ ];

    res.render("restaurant/tabletype/index",{ role: authResult.role,tableTypeData: tableTypesResult });
};

const showCreate = async(req, res, next) => {
    const authResult = await Auth.getSessionData(req.session.token); 

    res.render("restaurant/tabletype/create",{ role: authResult.role });
};

const showManage = async(req, res, next) => {
    const { id } = req.params;
    const authResult = await Auth.getSessionData(req.session.token); 
    const tableTypesResult = await tableTypesModel.findOneBy('id',id);
    if(tableTypesResult == null) return res.status(404).send("Not Found.");

    res.render("restaurant/tabletype/manage",{ role: authResult.role,tableTypeData: tableTypesResult });
};

const createTableType = async(req, res, next) => {
    const { id,description,capacity_min,capacity_max } = req.body;
    const authResult = await Auth.getSessionData(req.session.token); 

    const result = await tableTypesModel.create({ id,description,capacity_min,capacity_max });

    res.redirect("/tabletype");
};

const updateTableType = async(req, res, next) => {
    const { tid,id,description,capacity_min,capacity_max } = req.body;
    const tableTypesResult = await tableTypesModel.findOneBy('id',tid);
    if(tableTypesResult == null) return res.status(404).send("Not Found.");

    await tableTypesModel.updateBy('id',tid,{ id,description,capacity_min,capacity_max });

    res.redirect("/tabletype/manage/" + id);
};

const deleteTableType = async(req, res, next) => {
    const { id } = req.body;

    const result = await tableTypesModel.deleteById(id);

    res.redirect("/tabletype");
};

module.exports = {
    showIndex,
    showCreate,
    showManage,
    createTableType,
    updateTableType,
    deleteTableType
};